function varargout = GUI(varargin)
% GUI MATLAB code for GUI.fig
%      GUI, by itself, creates a new GUI or raises the existing
%      singleton*.
%
%      H = GUI returns the handle to a new GUI or the handle to
%      the existing singleton*.
%
%      GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI.M with the given input arguments.
%
%      GUI('Property','Value',...) creates a new GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before GUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to GUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help GUI

% Last Modified by GUIDE v2.5 30-May-2013 12:22:29

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before GUI is made visible.
function GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to GUI (see VARARGIN)

% Choose default command line output for GUI
handles.output = hObject;

% Update settings window
csSettings = importdata('settings.m', '\n');
set(handles.editSettings, 'String', csSettings);

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes GUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = GUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function edit1_Callback(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit1 as text
%        str2double(get(hObject,'String')) returns contents of edit1 as a double


% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnLoadVideo.
function btnLoadVideo_Callback(hObject, eventdata, handles)
% hObject    handle to btnLoadVideo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles   in: {handles.edit1}
%           out: {vidfile, vidobj}

[FileName,PathName,FilterIndex] = uigetfile('*.*','Select video file',get(handles.edit1, 'String'));
if FilterIndex
    try
        handles.vidFname = fullfile(PathName, FileName);
        set(handles.edit1, 'String', handles.vidFname);
        h = msgbox('Loading... (this will close automatically)');
        handles.vidobj = VideoReader(handles.vidFname);
        handles.vidobj
        try close(h); catch, end;   
        set(handles.btnSync, 'Enable', 'on');
        set(handles.btnBackground, 'Enable', 'off');
        set(handles.btnTrack, 'Enable', 'off');
        set(handles.btnPreview, 'Enable', 'off');    
        set(handles.panelPlot, 'Visible', 'off');
        guidata(hObject, handles);
        msgbox('Video file loaded');        
    catch
        errordlg(lasterr);
    end
end



function editSettings_Callback(hObject, eventdata, handles)
% hObject    handle to editSettings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editSettings as text
%        str2double(get(hObject,'String')) returns contents of editSettings as a double


% --- Executes during object creation, after setting all properties.
function editSettings_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editSettings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    in: editSettings


% --- Executes on button press in btnBackground.
function btnBackground_Callback(hObject, eventdata, handles)
% hObject    handle to btnBackground (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

LOADSETTINGS;
FLIM = handles.FLIM;
Frame1 = FLIM(1);

% Create a background
ans = inputdlg({'Second image frame #'}, 'Background', 1, {sprintf('%0.0f', FLIM(2))});
Frame2 = str2double(ans{1});
h=msgbox('Loading... (this will close automatically)');
img1 = read(handles.vidobj, Frame1); img1=img1(:,:,1);
img2 = read(handles.vidobj, Frame2); img2=img2(:,:,1);
try close(h); catch, end;
[img00, MASK, xy_init, vec0, xy0] = makeBackground(img1, img2);

% Update handles structure
handles.img00 = img00;
handles.img1 = img1; %first image frame
handles.MASK = MASK;
handles.xy_init = xy_init;
handles.vec0 = vec0;
handles.xy0 = xy0;
guidata(hObject, handles);
set(handles.btnPreview, 'Enable', 'on');


% --- Executes on button press in btnTrack.
function btnTrack_Callback(hObject, eventdata, handles)
% hObject    handle to btnTrack (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

LOADSETTINGS;
handles.SE = strel('disk', BW_SMOOTH,0); %use disk size 3 for 640 480
handles.img0 = handles.img00 * (1-IM_MINCONTRAST); %make it darker
handles.fShow = 1;
handles.ThreshLim = ThreshLim;
TC = handles.TC;

try
    [XC, YC, AC, Area, S1] = trackFish(handles, handles.FLIM);
catch
    errordlg(lasterr);
end

% save result of visual tracking
xy_names = S1.xy_names;
ang_names = S1.ang_names;
eval(sprintf('save %s TC XC YC AC Area handles xy_names ang_names;', 'output.mat'));
msgbox('Output saved to output.mat');

% Update figure handle
handles.XC = XC;
handles.YC = YC;
handles.AC = AC;
guidata(hObject, handles);
set(handles.panelPlot, 'Visible', 'on');


% --- Executes on button press in btnSync.
function btnSync_Callback(hObject, eventdata, handles)
% hObject    handle to btnSync (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

LOADSETTINGS;
vidobj = handles.vidobj;
% FPS_cam = get(vidobj, 'FrameRate');

h=msgbox('Loading... (this will close automatically)');
FLIM1 = [1 300];
FLIM1(2) = min(FLIM1(2), vidobj.NumberOfFrames);
implay(read(vidobj, FLIM1));
try close(h); catch, end;
uiwait(msgbox('Find the first brightest blink, and close the movie'));
ans = inputdlg('Frame Number', 'First frame',1,{'32'});
FLIM0(1) = str2num(ans{1});

try
    FLIM0(2) = round(FLIM0(1) + FPS_cam * diff(TLIM0));
    FLIM1 = FLIM0(2) + [-50 50]; 
    FLIM1(2) = min(FLIM1(2), vidobj.NumberOfFrames);
    h=msgbox('Loading... (this will close automatically)');
    implay(read(vidobj,FLIM1));
    try close(h); catch, end;
    uiwait(msgbox('Find the first brightest blink, and close the movie'));
    ans = inputdlg('Frame Number', 'Last frame',1,{'51'});
    temp = str2num(ans{1});
    FLIM0(2) = FLIM0(2)-50+temp-1;
catch
    errordlg('Check the TLIM0 setting (ADC time range)');
    return;
end

FLIM = FLIM0; %process all frames within the range

% determine the camera time stamp
TC = interp1(FLIM0, TLIM0, FLIM(1):FLIM(2), 'linear');
TLIM = interp1(FLIM0, TLIM0, FLIM([1 end]), 'linear');
FPS = diff(FLIM0)/diff(TLIM0);
fprintf('FPS = %0.6f Hz, TLIM0=[%d, %d], FLIM0=[%d, %d]\n', FPS, TLIM0(1), TLIM0(2), FLIM0(1), FLIM0(2));

% Update handles structure
handles.TC = TC;
handles.TLIM = TLIM;
handles.FPS = FPS;
handles.FLIM = FLIM;
guidata(hObject, handles);
set(handles.btnBackground, 'Enable', 'on');


% --- Executes on button press in btnPreview.
function btnPreview_Callback(hObject, eventdata, handles)
% hObject    handle to btnPreview (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

LOADSETTINGS;
handles.SE = strel('disk', BW_SMOOTH,0); %use disk size 3 for 640 480
img0 = handles.img00 * (1-IM_MINCONTRAST); %make it darker

% Initial
[WINPOS, ~] = getBoundingBoxPos(handles.xy_init, size(img0), winlen*[1 1]);
img = handles.img1(WINPOS(3):WINPOS(4), WINPOS(1):WINPOS(2));
dimg = uint8(img0(WINPOS(3):WINPOS(4), WINPOS(1):WINPOS(2))-img); 
BW = imdilate(bwmorph((dimg > IM_THRESH), 'clean', inf), handles.SE);
BW = imfill(BW, 'holes');
[BW, AreaTarget] = bwgetlargestblob(BW);

% Update
handles.thresh = IM_THRESH;
handles.AreaTarget = AreaTarget;
handles.WINPOS = WINPOS;
handles.img0 = img0;
guidata(hObject, handles);
set(handles.btnTrack, 'Enable', 'on');

% Preview images
figure; 
subplot 221; imshow(img);  
title('1. Original image');

subplot 222; 
imagesc(dimg); 
axis equal; axis tight; 
set(gca, {'XTick', 'YTick'}, {[], []});
title('2. Difference image');

subplot 223; imshow(BW);
title(sprintf('3. Binary image (Area=%d)', AreaTarget));    

subplot 224;  
BW1 = bwperim(BW);
img4 = img; img4(BW1)=255;     
imshow(img4); 
title('4. Superimposed');
colormap gray;


% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

writeText('settings.m', get(handles.editSettings, 'String'));
delete(hObject);


% --- Executes during object deletion, before destroying properties.
function figure1_DeleteFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton9.
function pushbutton9_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
writeText('settings.m', get(handles.editSettings, 'String'));



function editADCfile_Callback(hObject, eventdata, handles)
% hObject    handle to editADCfile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editADCfile as text
%        str2double(get(hObject,'String')) returns contents of editADCfile as a double


% --- Executes during object creation, after setting all properties.
function editADCfile_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editADCfile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnLoadADC.
function btnLoadADC_Callback(hObject, eventdata, handles)
% hObject    handle to btnLoadADC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[FileName,PathName,FilterIndex] = uigetfile('*.mat','Select ADC file',get(handles.editADCfile, 'String'));
if FilterIndex
    try
        handles.ADCfile = fullfile(PathName, FileName);
        set(handles.editADCfile, 'String', handles.ADCfile);
        h = msgbox('Loading... (this will close automatically)');
        handles.ADC = load(handles.ADCfile);
        try close(h); catch, end;        
        guidata(hObject, handles);
        msgbox('ADC File loaded');
    catch
        try close(h); catch, end;
        set(handles.editADCfile, 'String', '');
        errordlg(lasterr);
    end
end


% --- Executes on button press in pushbutton11.
function pushbutton11_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton12.
function pushbutton12_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton13.
function pushbutton13_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton16.
function pushbutton16_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton16 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in btnPlot2.
function btnPlot2_Callback(hObject, eventdata, handles)
% hObject    handle to btnPlot2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
LOADSETTINGS;
XC = handles.XC;
YC = handles.YC;

figure; imshow(handles.img0); title('Posture trajectory (red: more recent, circle: head)');
hold on;

nframes = size(XC,1);
nxy = size(XC,2);
mrColor = jet(nframes);
for iframe=1:TRAJ_STEP:nframes
    XI = interp1(2:nxy, XC(iframe,2:end), 2:.1:nxy, 'spline');
    YI = interp1(2:nxy, YC(iframe,2:end), 2:.1:nxy, 'spline');
    plot(XI, YI, 'color', mrColor(iframe,:));
    plot(XI(1), YI(1), 'o', 'color', mrColor(iframe,:));
end


% --- Executes on button press in btnPlot4.
function btnPlot4_Callback(hObject, eventdata, handles)
% hObject    handle to btnPlot4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

LOADSETTINGS;
TC = handles.TC;
try
    ADC = handles.ADC;
catch
    errordlg('Load ADC file');
    return;
end
    
%smooth and interpolate position
XCf_h = filtPos(handles.XC(:,2), TRAJ_NFILT);    
YCf_h = filtPos(handles.YC(:,2), TRAJ_NFILT);
TCi = TC(1):(1/EODR_SR):TC(end);
Xi = interp1(handles.TC, XCf_h, TCi, 'spline'); 
Yi = interp1(handles.TC, YCf_h, TCi, 'spline'); 

% Resample EOD Rate to camera time
csFieldnames = fieldnames(ADC);
S = getfield(handles.ADC, csFieldnames{1});
EODR = S.values;
TEOD = (1:numel(EODR)) * S.interval;
TEOD(1) = [];
EODR(1) = [];
% figure; plot(TEOD, EODR);

%convert rate to 0..255 color level at the camera time
R = interp1(TEOD, EODR, TCi);
R = (R-min(R))/(max(R)-min(R));
viColorRate = ceil(R * 256);
viColorRate(viColorRate<=0)=1;
mrColor = jet(256);
% figure; plot(handles.TC, viColorRate);

% Plot the EOD color representation
figure; imagesc(handles.img0); 
set(gca, {'XTick', 'YTick'}, {[],[]}); axis equal; axis tight;
hold on; 
title('EOD rate at the head trajectory (red: higher rate)');

for i=1:numel(viColorRate)
    plot(Xi(i), Yi(i), '.', 'color', mrColor(viColorRate(i),:));
    hold on;
end
colormap gray;


% --- Executes on button press in btnPlot1.
function btnPlot1_Callback(hObject, eventdata, handles)
% hObject    handle to btnPlot1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
LOADSETTINGS;
XC = handles.XC;
YC = handles.YC;

% filter position
nf = TRAJ_NFILT;
XCf_h = filtPos(XC(:,2),nf);    YCf_h = filtPos(YC(:,2),nf);
XCf_hm = filtPos(XC(:,3),nf);   YCf_hm = filtPos(YC(:,3),nf);
XCf_m = filtPos(XC(:,4),nf);    YCf_m = filtPos(YC(:,4),nf);
XCf_tm = filtPos(XC(:,5),nf);    YCf_tm = filtPos(YC(:,5),nf);
XCf_t = filtPos(XC(:,6),nf);    YCf_t = filtPos(YC(:,6),nf);

figure; imshow(handles.img0); title('Trajectory of the rostral tip');
hold on; plot(XCf_h, YCf_h);
pause(.4);
hold on; comet(XCf_h, YCf_h, .1);


% --- Executes on button press in btnPlot3.
function btnPlot3_Callback(hObject, eventdata, handles)
% hObject    handle to btnPlot3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
