function [img0, MASK, xyc, vec, xy0] = makeBackground(img1, img2)
%xyc: center of the fish's initial position
%xy0: center of the aquarium
%vec: initial heading direction (unit vec)

hfig = figure;
set(hfig, 'Position', [10 50 1010 505]);
subplot 121; imshow(img1);  title('First frame');
subplot 122; imshow(img2);  title('Second frame');

% Crop out a fish from the first image
subplot 121;
uiwait(msgbox('Drag a box around the fish on the left image and double-click', 'modal'));
title('Draw a box around and double-click');
h  = imrect;
position = wait(h);
MASK = createMask(h);
xc=round(position(1)+position(3)/2);
yc=round(position(2)+position(4)/2);
xyc = [xc yc];
img0 = img1;
img0(MASK) = img2(MASK);   

% Define the head orientation
% uiwait(msgbox('Click on the head', 'modal'));
title('Click on the head');
xyh = ginput(1);
vec = xyh - xyc;
vec = vec ./ norm(vec);

% Draw a mask
figure(hfig); clf; imshow(img0);
uiwait(msgbox('Create a circular mask and double-click', 'modal'));
title('Create a circular mask and double-click');
h  = imellipse;
wait(h);
MASK = createMask(h);
img0(~MASK) = 0;

% Define the center of the aquarium
% uiwait(msgbox('Click at the center of the aquarium', 'modal'));
title('Click on the center of the aquarium');
xy0 = ginput(1);

% Final confirmation
figure(hfig); imshow(img0); %display
hold on; plot(xy0(1), xy0(2), 'r.');
title('Composite background image');
uiwait(msgbox('Composite background is created. Press OK to close.'));
close(hfig);

